# In[1]:


def banach(f,x_0,schritte):
    val=[x_0]
    for i in range(schritte):
        val.append(f(val[-1]))
    return val


# In[2]:


def f(x):
    return 2*x/3+14


# In[3]:


approx=banach(f,1,21)
approx


# In[4]:


#posteriori Fehler (mit L=2/3):
3*(f(approx[-1])-approx[-1]) #=1/(1-L)*|x_(n+1)-x_n|


# In[5]:


#echter Fehler
42-approx[-1]


# In[6]:


#a priori für x_0=0 und epsilon=0.0001
import numpy as np
n=np.log(0.0001/42)/np.log(2/3)
n


# In[7]:


approx=banach(f,0,32)
approx


# In[8]:


def g(x):
    return np.sqrt(x)+3


# In[9]:


# a priori fehler <0.1 für L=1/2 und x_0=2:
n=np.log(0.1)/np.log(1/2)+1 # entspricht L^n/(1-L)|f(x_0)-x_0|<0.1
n


# In[10]:


n=5
appr=banach(g,2,n)
appr


# In[11]:


print("A posterioi:")
print(2*(g(appr[-1])-appr[-1]))


# In[12]:


print("Echter Fehler:")
print(((7+np.sqrt(13))/2)-appr[-1])


# In[ ]:




